if not srb2p then return end

attackDefs["blossom_atk1"] = {
	name = "Tornado Drill",
	type = ATK_PIERCE,
	power = 40,
	accuracy = 95,
	critical = 7,
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	desc = "Dive down from above\nand crush your foes.",
	anim_norepel = true,
	physical = true,
	norandom = true,
	norogue = true,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local btl = server.P_BattleStatus[mo.battlen]
		local cam = btl.cam

		if timer == 1
			local cx = target.x + 168*cos(target.angle + ANG1*20)
			local cy = target.y + 168*sin(target.angle + ANG1*20)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
		elseif timer == 10
			ANIM_set(mo, mo.anim_atk, true)
			P_TeleportMove(mo, target.x + 4*cos(target.angle), target.y + 4*sin(target.angle), target.z + FRACUNIT*256)
			playSound(mo.battlen, sfx_s3k51)
			mo.momz = -FRACUNIT*24
		elseif timer >= 10 and timer < TICRATE + TICRATE/2 then
			if (leveltime & 1)
				local g = P_SpawnGhostMobj(mo)
				g.destscale = mo.scale*4
			end

			if mo.z <= target.z + FRACUNIT*32 then
				mo.z = target.z + FRACUNIT*32
				mo.momz = 0

				if leveltime%3 == 0 then
					createSplat(mo)
					local shot = P_SpawnMobj(target.x + P_RandomRange(-15, 15)*FRACUNIT, target.y + P_RandomRange(-15, 15)*FRACUNIT, target.z + P_RandomRange(16, 48)*FRACUNIT, MT_DUMMY)
					playSound(mo.battlen, sfx_rail1)
					shot.state = S_SHOT1
					shot.scale = $ + P_RandomRange(0, 65535)*3
					localquake(mo.battlen, FRACUNIT*10, 5)
				end
			end
		elseif timer == TICRATE + TICRATE/2
			damageObject(hittargets[1])
			P_InstaThrust(mo, target.angle, FRACUNIT*10)
			mo.momz = 10*FRACUNIT
		elseif timer == TICRATE*5/2
			mo.z = mo.floorz
			return true
		end
	end,
}

// WISP //
addHook("MobjThinker", function(mo)
	if not mo or not mo.valid then return end
	if not mo.hp or mo.hp <= 0 then return end

	if mo.linkstate and mo.linkstate.atkref and attackDefs[mo.linkstate.atkref] and attackDefs[mo.linkstate.atkref].wispeff then
		local rfac = (mo.maxhp + mo.maxsp) - mo.level

		local ang = (rfac + leveltime)*ANG1*12
		local zpos = mo.z + 32*mo.scale + 32*sin((rfac + leveltime)*ANG1*8)

		local x = mo.x + 64*cos(ang)
		local y = mo.y + 64*sin(ang)
		local f = P_SpawnMobj(x, y, zpos, MT_THOK)
		f.sprite = SPR_FPRT
		f.frame = $|FF_FULLBRIGHT|TR_TRANS10
		f.blendmode = AST_ADD
		f.scale = mo.scale*5/2
		f.color = SKINCOLOR_VIOLET
		f.colorized = true
		f.tics = 5
		f.fuse = 5

		local g = P_SpawnGhostMobj(f)
		g.destscale = 1
		g.scalespeed = FRACUNIT/4
		g.color = SKINCOLOR_VIOLET
		g.colorized = true
		g.blendmode = AST_ADD
	end

	if mo.linkstate and mo.linkstate.atkref and attackDefs[mo.linkstate.atkref] and attackDefs[mo.linkstate.atkref].risedead then
		local rfac = (mo.maxhp + mo.maxsp) - mo.level

		local ang = (rfac + leveltime)*ANG1*12
		local zpos = mo.z + 32*mo.scale + 32*sin((rfac + leveltime)*ANG1*8)

		local x = mo.x + 64*cos(ang)
		local y = mo.y + 64*sin(ang)
		local f = P_SpawnMobj(x, y, zpos, MT_THOK)
		f.sprite = SPR_FPRT
		f.frame = $|FF_FULLBRIGHT|TR_TRANS10
		f.blendmode = AST_ADD
		f.scale = mo.scale*5/2
		f.color = SKINCOLOR_CRIMSON
		f.colorized = true
		f.tics = 5
		f.fuse = 5

		local g = P_SpawnGhostMobj(f)
		g.destscale = 1
		g.scalespeed = FRACUNIT/4
		g.color = SKINCOLOR_CRIMSON
		g.colorized = true
		g.blendmode = AST_ADD
	end
end, MT_PFIGHTER)

SRB2P_addHook("FighterDamage", function(mo, attacker)
	local dmg = mo.redhp-mo.hp
	mo.wispdmg = dmg/2
	mo.risedeaddmg = dmg/2
end)

attackDefs["wisp"] = {
	name = "Wisp",
	type = ATK_CURSE,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Light Curse dmg to one enemy.\n".."\x82".."Curses".."\x80".." the enemy so\nthat they take half of the damage\nthe next attack deals.",
	target = TGT_ENEMY,
	link = true,
	wispeff = true,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		local target = hittargets[1]

		if btl.battlestate == BS_LINK then
			-- The Link attack.
			local thok
			if timer == 2 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 5*target.scale/2
				thok.destscale = 3*target.scale/2
				thok.scalespeed = target.scale/3
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = 6
				thok.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				thok.flags2 = MF2_SPLAT
				thok.color = SKINCOLOR_LAVENDER

				P_CreateFloorSpriteSlope(thok)
				thok.floorspriteslope.o = {
					x = thok.x+32*FRACUNIT,
					y = thok.y+32*FRACUNIT,
					z = thok.z
				}
			elseif timer == 8 then
				playSound(mo.battlen, sfx_s3k43)
				damageObject(target, target.wispdmg)

				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.destscale = 2*target.scale
				thok.scalespeed = target.scale/3
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|B
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 12 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|C
				thok.fuse = 4
			elseif timer == 16 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|D
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 20 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|E
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 24 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|F
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 28 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|G
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			end

			if timer >= 45 then return true end
		else
			if timer == 5 then
				playSound(mo.battlen, sfx_csnap)

				mo.fires = {}
				mo.beams = {}

				local fire
				for i = -1, 1, 2 do
					fire = P_SpawnMobjFromMobj(target, FixedMul(128*i*cos(target.angle+ANGLE_90), target.scale), FixedMul(128*i*sin(target.angle+ANGLE_90), target.scale), 48*target.scale, MT_DUMMY)
					fire.sprite = SPR_FPRT
					fire.color = SKINCOLOR_VIOLET
					fire.scale = 3*target.scale
					fire.colorized = true
					fire.tics = -1
					fire.fuse = -1

					mo.fires[#mo.fires+1] = fire
				end
			end

			if mo.fires and #mo.fires then
				local fire, ghost
				for i = 1, #mo.fires do
					fire = mo.fires[i]

					if fire and fire.valid then
						if not (leveltime%6) then
							fire.momx = P_RandomRange(-3, 3)*FRACUNIT
							fire.momy = P_RandomRange(-3, 3)*FRACUNIT
							fire.momz = P_RandomRange(-3, 3)*FRACUNIT
						end

						ghost = P_SpawnGhostMobj(fire)
						ghost.frame = FF_FULLBRIGHT|FF_TRANS10|$
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_LAVENDER
						ghost.momz = P_RandomRange(2, 9)*FRACUNIT
						ghost.destscale = 2*FRACUNIT
						ghost.tics = 4
						ghost.fuse = 4
					end
				end
			end

			if mo.beams and #mo.beams then
				local beam, o, dist
				for i = 1, #mo.beams do
					if mo.beams[i] and mo.beams[i].valid then
						beam = mo.beams[i]

						dist = P_AproxDistance(P_AproxDistance(target.x - beam.x, target.y - beam.y), target.z - beam.z)
						beam.momx = FixedMul(FixedDiv(target.x - beam.x, dist), 16*target.scale)
						beam.momy = FixedMul(FixedDiv(target.y - beam.y, dist), 16*target.scale)
						beam.momz = FixedMul(FixedDiv(target.z - beam.z, dist), 16*target.scale)

						if dist <= 16*FRACUNIT then
							damageObject(target)
							playSound(mo.battlen, sfx_megi6)
							localquake(mo.battlen, 16*FRACUNIT, 10)

							for k = 1, #mo.beams do
								P_RemoveMobj(mo.beams[k])
							end

							for k = 1, #mo.fires do
								P_RemoveMobj(mo.fires[k])
							end

							for k = 1, 16
								local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
								boom.state = S_CQUICKBOOM1
								boom.color = SKINCOLOR_LAVENDER
								boom.momx = P_RandomRange(-20, 20)*FRACUNIT
								boom.momy = P_RandomRange(-20, 20)*FRACUNIT
								boom.momz = P_RandomRange(-20, 20)*FRACUNIT
								boom.scale = FRACUNIT*3/2
							end

							mo.beams = nil
							mo.fires = nil
							break
						else
							o = P_SpawnMobjFromMobj(beam, 0, 0, 0, MT_THOK)
							o.color = SKINCOLOR_VIOLET
							o.scale = 2*target.scale/3
							o.destscale = 1
							o.tics = 35
							o.fuse = 35
							o.frame = FF_FULLBRIGHT|FF_TRANS10|A
							o.blendmode = AST_ADD
						end
					end
				end
			end

			if timer == 35 then
				playSound(mo.battlen, sfx_s3k43)

				local o
				for i = 1, #mo.fires do
					if mo.fires[i] and mo.fires[i].valid then
						o = P_SpawnMobjFromMobj(mo.fires[i], 0, 0, 0, MT_THOK)
						o.scale = 2*target.scale/3
						o.color = SKINCOLOR_WHITE
						o.tics = 70
						o.fuse = 70
						o.frame = FF_FULLBRIGHT|FF_TRANS10|A
						mo.beams[#mo.beams+1] = o
					end
				end
			end

			if timer >= 80 then
				mo.beams = nil
				mo.fires = nil
				return true
			end
		end
	end,
}

attackDefs["will o wisp"] = {
	name = "Will-O-Wisp",
	type = ATK_CURSE,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Medium Curse dmg to one enemy.\n".."\x82".."Curses".."\x80".." the enemy so\nthat they take half of the damage\nthe next attack deals.",
	target = TGT_ENEMY,
	link = true,
	wispeff = true,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		local target = hittargets[1]

		if btl.battlestate == BS_LINK then
			-- The Link attack.
			local thok
			if timer == 2 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 5*target.scale/2
				thok.destscale = 3*target.scale/2
				thok.scalespeed = target.scale/3
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = 6
				thok.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				thok.flags2 = MF2_SPLAT
				thok.color = SKINCOLOR_LAVENDER

				P_CreateFloorSpriteSlope(thok)
				thok.floorspriteslope.o = {
					x = thok.x+32*FRACUNIT,
					y = thok.y+32*FRACUNIT,
					z = thok.z
				}
			elseif timer == 8 then
				playSound(mo.battlen, sfx_s3k43)
				damageObject(target, target.wispdmg)

				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.destscale = 2*target.scale
				thok.scalespeed = target.scale/3
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|B
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 12 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|C
				thok.fuse = 4
			elseif timer == 16 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|D
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 20 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|E
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 24 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|F
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 28 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|G
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			end

			if timer >= 45 then return true end
		else
			if timer == 5 then
				playSound(mo.battlen, sfx_csnap)

				mo.fires = {}
				mo.beams = {}

				local fire
				for i = -3, 3, 2 do
					fire = P_SpawnMobjFromMobj(target, FixedMul(64*i*cos(target.angle+ANGLE_90), target.scale), FixedMul(64*i*sin(target.angle+ANGLE_90), target.scale), 48*target.scale, MT_DUMMY)
					fire.sprite = SPR_FPRT
					fire.color = SKINCOLOR_VIOLET
					fire.scale = 3*target.scale
					fire.colorized = true
					fire.tics = -1
					fire.fuse = -1

					mo.fires[#mo.fires+1] = fire
				end
			end

			if mo.fires and #mo.fires then
				local fire, ghost
				for i = 1, #mo.fires do
					fire = mo.fires[i]

					if fire and fire.valid then
						if not (leveltime%6) then
							fire.momx = P_RandomRange(-3, 3)*FRACUNIT
							fire.momy = P_RandomRange(-3, 3)*FRACUNIT
							fire.momz = P_RandomRange(-3, 3)*FRACUNIT
						end

						ghost = P_SpawnGhostMobj(fire)
						ghost.frame = FF_FULLBRIGHT|FF_TRANS10|$
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_LAVENDER
						ghost.momz = P_RandomRange(2, 9)*FRACUNIT
						ghost.destscale = 2*FRACUNIT
						ghost.tics = 4
						ghost.fuse = 4
					end
				end
			end

			if mo.beams and #mo.beams then
				local beam, o, dist
				for i = 1, #mo.beams do
					if mo.beams[i] and mo.beams[i].valid then
						beam = mo.beams[i]

						dist = P_AproxDistance(P_AproxDistance(target.x - beam.x, target.y - beam.y), target.z - beam.z)
						beam.momx = FixedMul(FixedDiv(target.x - beam.x, dist), 16*target.scale)
						beam.momy = FixedMul(FixedDiv(target.y - beam.y, dist), 16*target.scale)
						beam.momz = FixedMul(FixedDiv(target.z - beam.z, dist), 16*target.scale)

						if dist <= 16*FRACUNIT then
							playSound(mo.battlen, sfx_megi6)
							localquake(mo.battlen, 16*FRACUNIT, 10)

							P_RemoveMobj(mo.beams[i])
							table.remove(mo.beams, i)

							for k = 1, 16
								local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
								boom.state = S_CQUICKBOOM1
								boom.color = SKINCOLOR_LAVENDER
								boom.momx = P_RandomRange(-20, 20)*FRACUNIT
								boom.momy = P_RandomRange(-20, 20)*FRACUNIT
								boom.momz = P_RandomRange(-20, 20)*FRACUNIT
								boom.scale = FRACUNIT*3/2
							end

							mo.shoots = $-1
							if mo.shoots <= 0 then
								damageObject(target)

								for k = 1, #mo.beams do
									if mo.beams[k] and mo.beams[k].valid then P_RemoveMobj(mo.beams[k]) end
								end

								for k = 1, #mo.fires do
									if mo.fires[k] and mo.fires[k].valid then P_RemoveMobj(mo.fires[k]) end
								end

								mo.shoots = nil
								mo.beams = nil
								mo.fires = nil
								break
							end
						else
							o = P_SpawnMobjFromMobj(beam, 0, 0, 0, MT_THOK)
							o.color = SKINCOLOR_VIOLET
							o.scale = 2*target.scale/3
							o.destscale = 1
							o.tics = 35
							o.fuse = 35
							o.frame = FF_FULLBRIGHT|FF_TRANS10|A
							o.blendmode = AST_ADD
						end
					end
				end
			end

			if timer == 35 then mo.shoots = 10 end

			if timer > 35 and mo.fires and #mo.fires then
				playSound(mo.battlen, sfx_s3k43)

				local o
				for i = 1, #mo.fires do
					if not ((timer+(i*4))%10) and mo.fires[i] and mo.fires[i].valid then
						o = P_SpawnMobjFromMobj(mo.fires[i], 0, 0, 0, MT_THOK)
						o.scale = 2*target.scale/3
						o.color = SKINCOLOR_WHITE
						o.tics = 70
						o.fuse = 70
						o.frame = FF_FULLBRIGHT|FF_TRANS10|A
						mo.beams[#mo.beams+1] = o
					end
				end
			end

			if (not mo.shoots or mo.shoots <= 0) and timer <= 100 and timer > 35 and not (timer%5) then
				local caman = R_PointToAngle(target.x, target.y)

				local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.frame = FF_FULLBRIGHT|FF_TRANS10|D
				t.color = SKINCOLOR_VIOLET
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
				t.blendmode = AST_ADD
				t.tics = -1
			end

			if timer >= 120 then
				mo.beams = nil
				mo.fires = nil
				return true
			end
		end
	end,
}

attackDefs["ignis fatuus"] = {
	name = "Ignis Fatuus",
	type = ATK_CURSE,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 20,
	desc = "Heavy Curse dmg to one enemy.\n".."\x82".."Curses".."\x80".." the enemy so\nthat they take half of the damage\nthe next attack deals.",
	target = TGT_ENEMY,
	link = true,
	wispeff = true,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		local target = hittargets[1]

		if btl.battlestate == BS_LINK then
			-- The Link attack.
			local thok
			if timer == 2 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 5*target.scale/2
				thok.destscale = 3*target.scale/2
				thok.scalespeed = target.scale/3
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = 6
				thok.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				thok.flags2 = MF2_SPLAT
				thok.color = SKINCOLOR_LAVENDER

				P_CreateFloorSpriteSlope(thok)
				thok.floorspriteslope.o = {
					x = thok.x+32*FRACUNIT,
					y = thok.y+32*FRACUNIT,
					z = thok.z
				}
			elseif timer == 8 then
				playSound(mo.battlen, sfx_s3k43)
				damageObject(target, target.wispdmg)

				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.destscale = 2*target.scale
				thok.scalespeed = target.scale/3
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|B
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 12 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|C
				thok.fuse = 4
			elseif timer == 16 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|D
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 20 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|E
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 24 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|F
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 28 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|G
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			end

			if timer >= 45 then return true end
		else
			if timer == 5 then
				playSound(mo.battlen, sfx_csnap)

				mo.fires = {}
				mo.beams = {}

				local fire
				for i = -5, 5, 2 do
					fire = P_SpawnMobjFromMobj(target, FixedMul(64*i*cos(target.angle+ANGLE_90), target.scale), FixedMul(64*i*sin(target.angle+ANGLE_90), target.scale), 48*target.scale, MT_DUMMY)
					fire.sprite = SPR_FPRT
					fire.color = SKINCOLOR_VIOLET
					fire.scale = 3*target.scale
					fire.colorized = true
					fire.tics = -1
					fire.fuse = -1

					mo.fires[#mo.fires+1] = fire
				end
			end

			if mo.fires and #mo.fires then
				local fire, ghost
				for i = 1, #mo.fires do
					fire = mo.fires[i]

					if fire and fire.valid then
						if not (leveltime%6) then
							fire.momx = P_RandomRange(-3, 3)*FRACUNIT
							fire.momy = P_RandomRange(-3, 3)*FRACUNIT
							fire.momz = P_RandomRange(-3, 3)*FRACUNIT
						end

						ghost = P_SpawnGhostMobj(fire)
						ghost.frame = FF_FULLBRIGHT|FF_TRANS10|$
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_LAVENDER
						ghost.momz = P_RandomRange(2, 9)*FRACUNIT
						ghost.destscale = 2*FRACUNIT
						ghost.tics = 4
						ghost.fuse = 4
					end
				end
			end

			if mo.beams and #mo.beams then
				local beam, o, dist
				for i = 1, #mo.beams do
					if mo.beams[i] and mo.beams[i].valid then
						beam = mo.beams[i]

						dist = P_AproxDistance(P_AproxDistance(target.x - beam.x, target.y - beam.y), target.z - beam.z)
						beam.momx = FixedMul(FixedDiv(target.x - beam.x, dist), 16*target.scale)
						beam.momy = FixedMul(FixedDiv(target.y - beam.y, dist), 16*target.scale)
						beam.momz = FixedMul(FixedDiv(target.z - beam.z, dist), 16*target.scale)

						if dist <= 16*FRACUNIT then
							playSound(mo.battlen, sfx_megi6)
							localquake(mo.battlen, 16*FRACUNIT, 10)

							P_RemoveMobj(mo.beams[i])
							table.remove(mo.beams, i)

							for k = 1, 16
								local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
								boom.state = S_CQUICKBOOM1
								boom.color = SKINCOLOR_LAVENDER
								boom.momx = P_RandomRange(-20, 20)*FRACUNIT
								boom.momy = P_RandomRange(-20, 20)*FRACUNIT
								boom.momz = P_RandomRange(-20, 20)*FRACUNIT
								boom.scale = FRACUNIT*3/2
							end

							mo.shoots = $-1
							if mo.shoots <= 0 then
								damageObject(target)

								for k = 1, #mo.beams do
									if mo.beams[k] and mo.beams[k].valid then P_RemoveMobj(mo.beams[k]) end
								end

								for k = 1, #mo.fires do
									if mo.fires[k] and mo.fires[k].valid then P_RemoveMobj(mo.fires[k]) end
								end

								mo.shoots = nil
								mo.beams = nil
								mo.fires = nil
								break
							end
						else
							o = P_SpawnMobjFromMobj(beam, 0, 0, 0, MT_THOK)
							o.color = SKINCOLOR_VIOLET
							o.scale = 2*target.scale/3
							o.destscale = 1
							o.tics = 35
							o.fuse = 35
							o.frame = FF_FULLBRIGHT|FF_TRANS10|A
							o.blendmode = AST_ADD
						end
					end
				end
			end

			if timer == 35 then mo.shoots = 15 end

			if timer > 35 and mo.fires and #mo.fires then
				playSound(mo.battlen, sfx_s3k43)

				local o
				for i = 1, #mo.fires do
					if not ((timer+(i*4))%10) and mo.fires[i] and mo.fires[i].valid then
						o = P_SpawnMobjFromMobj(mo.fires[i], 0, 0, 0, MT_THOK)
						o.scale = 2*target.scale/3
						o.color = SKINCOLOR_WHITE
						o.tics = 70
						o.fuse = 70
						o.frame = FF_FULLBRIGHT|FF_TRANS10|A
						mo.beams[#mo.beams+1] = o
					end
				end
			end

			if (not mo.shoots or mo.shoots <= 0) and timer <= 100 and timer > 35 and not (timer%5) then
				local caman = R_PointToAngle(target.x, target.y)

				local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.frame = FF_FULLBRIGHT|FF_TRANS10|D
				t.color = SKINCOLOR_VIOLET
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
				t.blendmode = AST_ADD
				t.tics = -1
			end

			if timer >= 120 then
				mo.beams = nil
				mo.fires = nil
				return true
			end
		end
	end,
}

attackDefs["rise the dead"] = {
	name = "Rise the dead!",
	type = ATK_CURSE,
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 38,
	desc = "Severe Curse dmg to one enemy.\n".."\x82".."Curses".."\x80".." the enemy so\nthat they take the damage\nthe next attack deals again.",
	target = TGT_ENEMY,
	link = true,
	risedead = true,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		local target = hittargets[1]

		if btl.battlestate == BS_LINK then
			-- The Link attack.
			local thok
			if timer == 2 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 5*target.scale/2
				thok.destscale = 3*target.scale/2
				thok.scalespeed = target.scale/3
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = 6
				thok.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				thok.flags2 = MF2_SPLAT
				thok.color = SKINCOLOR_LAVENDER

				P_CreateFloorSpriteSlope(thok)
				thok.floorspriteslope.o = {
					x = thok.x+32*FRACUNIT,
					y = thok.y+32*FRACUNIT,
					z = thok.z
				}
			elseif timer == 8 then
				playSound(mo.battlen, sfx_s3k43)
				damageObject(target, target.risdeaddmg)

				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.destscale = 2*target.scale
				thok.scalespeed = target.scale/3
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|B
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 12 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|C
				thok.fuse = 4
			elseif timer == 16 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|D
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 20 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|E
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 24 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|F
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			elseif timer == 28 then
				thok = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_DUMMY)
				thok.scale = 2*target.scale
				thok.sprite = SPR_BRND
				thok.frame = FF_FULLBRIGHT|G
				thok.fuse = 4
				thok.color = SKINCOLOR_LAVENDER
			end

			if timer >= 45 then return true end
		else
			if timer == 5 then
				playSound(mo.battlen, sfx_csnap)

				mo.fires = {}
				mo.beams = {}

				local fire
				for i = -5, 5, 2 do
					fire = P_SpawnMobjFromMobj(target, FixedMul(64*i*cos(target.angle+ANGLE_90), target.scale), FixedMul(64*i*sin(target.angle+ANGLE_90), target.scale), 48*target.scale, MT_DUMMY)
					fire.sprite = SPR_FPRT
					fire.color = SKINCOLOR_VIOLET
					fire.scale = 3*target.scale
					fire.colorized = true
					fire.tics = -1
					fire.fuse = -1

					mo.fires[#mo.fires+1] = fire
				end
			end

			if mo.fires and #mo.fires then
				local fire, ghost
				for i = 1, #mo.fires do
					fire = mo.fires[i]

					if fire and fire.valid then
						if not (leveltime%6) then
							fire.momx = P_RandomRange(-3, 3)*FRACUNIT
							fire.momy = P_RandomRange(-3, 3)*FRACUNIT
							fire.momz = P_RandomRange(-3, 3)*FRACUNIT
						end

						ghost = P_SpawnGhostMobj(fire)
						ghost.frame = FF_FULLBRIGHT|FF_TRANS10|$
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_LAVENDER
						ghost.momz = P_RandomRange(2, 9)*FRACUNIT
						ghost.destscale = 2*FRACUNIT
						ghost.tics = 4
						ghost.fuse = 4
					end
				end
			end

			if mo.beams and #mo.beams then
				local beam, o, dist
				for i = 1, #mo.beams do
					if mo.beams[i] and mo.beams[i].valid then
						beam = mo.beams[i]

						dist = P_AproxDistance(P_AproxDistance(target.x - beam.x, target.y - beam.y), target.z - beam.z)
						beam.momx = FixedMul(FixedDiv(target.x - beam.x, dist), 16*target.scale)
						beam.momy = FixedMul(FixedDiv(target.y - beam.y, dist), 16*target.scale)
						beam.momz = FixedMul(FixedDiv(target.z - beam.z, dist), 16*target.scale)

						if dist <= 16*FRACUNIT then
							playSound(mo.battlen, sfx_megi6)
							localquake(mo.battlen, 16*FRACUNIT, 10)

							P_RemoveMobj(mo.beams[i])
							table.remove(mo.beams, i)

							for k = 1, 16
								local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
								boom.state = S_CQUICKBOOM1
								boom.color = SKINCOLOR_LAVENDER
								boom.momx = P_RandomRange(-20, 20)*FRACUNIT
								boom.momy = P_RandomRange(-20, 20)*FRACUNIT
								boom.momz = P_RandomRange(-20, 20)*FRACUNIT
								boom.scale = FRACUNIT*3/2
							end

							mo.shoots = $-1
							if mo.shoots <= 0 then
								damageObject(target)

								for k = 1, #mo.beams do
									if mo.beams[k] and mo.beams[k].valid then P_RemoveMobj(mo.beams[k]) end
								end

								for k = 1, #mo.fires do
									if mo.fires[k] and mo.fires[k].valid then P_RemoveMobj(mo.fires[k]) end
								end

								mo.shoots = nil
								mo.beams = nil
								mo.fires = nil
								break
							end
						else
							o = P_SpawnMobjFromMobj(beam, 0, 0, 0, MT_THOK)
							o.color = SKINCOLOR_VIOLET
							o.scale = 2*target.scale/3
							o.destscale = 1
							o.tics = 35
							o.fuse = 35
							o.frame = FF_FULLBRIGHT|FF_TRANS10|A
							o.blendmode = AST_ADD
						end
					end
				end
			end

			if timer == 35 then mo.shoots = 15 end

			if timer > 35 and mo.fires and #mo.fires then
				playSound(mo.battlen, sfx_s3k43)

				local o
				for i = 1, #mo.fires do
					if not ((timer+(i*4))%10) and mo.fires[i] and mo.fires[i].valid then
						o = P_SpawnMobjFromMobj(mo.fires[i], 0, 0, 0, MT_THOK)
						o.scale = 2*target.scale/3
						o.color = SKINCOLOR_WHITE
						o.tics = 70
						o.fuse = 70
						o.frame = FF_FULLBRIGHT|FF_TRANS10|A
						mo.beams[#mo.beams+1] = o
					end
				end
			end

			if (not mo.shoots or mo.shoots <= 0) and timer <= 100 and timer > 35 and not (timer%5) then
				local caman = R_PointToAngle(target.x, target.y)

				local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.frame = FF_FULLBRIGHT|FF_TRANS10|D
				t.color = SKINCOLOR_VIOLET
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
				t.blendmode = AST_ADD
				t.tics = -1

				for i = 1, 4 do
					t = P_SpawnMobj(target.x + 2*cos(leveltime*ANG1 + (i*ANGLE_90)), target.y + 2*cos(leveltime*ANG1 + (i*ANGLE_90)), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.frame = FF_FULLBRIGHT|FF_TRANS10|D
					t.color = SKINCOLOR_CRIMSON
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
					t.blendmode = AST_ADD
					t.tics = -1
				end
			end

			if timer >= 120 then
				mo.beams = nil
				mo.fires = nil
				return true
			end
		end
	end,
}

/*
attackDefs["fear drain"] = {
	name = "Fear Drain",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 5,
	desc = "Only works on hexed foes.\nClears hex, but afflicts a draining\npoison that slowly deteriorates\nstats.",
	target = TGT_ENEMY,
	debuff = true,
	nocast = function(targets, n)	-- we can't cast this skill if this function returns true
		local target = targets[n]
		if target.status_condition ~= COND_HEX then
			BTL_logMessage(targets[1].battlen, "Only works on hexed foes.")
			return true
		end
	end,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
	end,
}
*/

-- Basic, should change.
attackDefs["trepidation"] = {
	name = "Trepidation",
	type = ATK_PASSIVE,
	desc = "Heal HP when attacking Hexed or Poisoned foes. ",
	passive = PSV_ONDAMAGE,
	anim = function(mo, target)
		if target != mo and (target.status_condition == COND_HEX or target.status_condition == COND_POISON) then
			damageObject(mo, -mo.maxhp/10)
		end
	end,
}