addHook("PlayerThink", function(p)
	Flimp_MainThinker(p)
end)

addHook("PlayerCanDamage", function(p, mo)
	if p.mo.flimp_headbutting then return true end
	if p.mo.flimp_diving then return true end
end)

addHook("MobjCollide", Flimp_SpringHandler, MT_PLAYER)
addHook("MobjMoveCollide", Flimp_SpringHandler, MT_PLAYER)

addHook("MobjDamage", function(mo, inf, src, d, dt)
	mo.flimp_headbutting = nil
	mo.flimp_diving = nil
	mo.flimp_flying = nil
	mo.flimp_flight = nil
	mo.flimp_didflying = nil
	mo.flimp_diddive = nil
	mo.flimp_nodive = nil
	mo.flimp_squish = nil
	mo.flimp_duckdance = nil
	mo.spritexscale = FRACUNIT
	mo.spriteyscale = FRACUNIT
	mo.player.pflags = $ & ~PF_CANCARRY
end, MT_PLAYER)

-- ShouldDamage
local function fire_spread(obj, i)
	local fire

	for _ = 1, i do
		fire = P_SpawnMobjFromMobj(obj, 0, 0, 0, MT_THOK)

		if not fire or not fire.valid then return end

		fire.sprite = SPR_SFBR
		fire.frame = FF_FULLBRIGHT|FF_TRANS20|A
		fire.rollangle = P_RandomRange(0, 360)*ANG1
		fire.momx = P_RandomRange(-6, 6)*FRACUNIT
		fire.momy = P_RandomRange(-6, 6)*FRACUNIT
		fire.momz = P_RandomRange(-6, 6)*FRACUNIT
		fire.color = SKINCOLOR_LAVENDER
		fire.colorized = true
		fire.destscale = 1
		fire.fuse = 35
		fire.tics = 35
	end
end

addHook("ShouldDamage", function(t, i, s, d, dt)
	if (dt & DMG_DEATHMASK) then return end
	if t.skin ~= "flimp" then return end

	if t.flimp_parry and t.flimp_parry >= 18 then
		t.flimp_parry = nil
		t.flimp_parry_invuln = 35
		S_StartSound(t, sfx_fparr2)

		if i and i.valid then
			P_DamageMobj(i, t, t, d)
			fire_spread(i, 5)
		end

		if s and s.valid then
			P_DamageMobj(s, t, t, d)
			fire_spread(s, 5)
		end

		fire_spread(t, 5)

		return false
	end

	if t.flimp_parry_invuln then return false end
end, MT_PLAYER)