local function flightDamage(pmo, mobj)
	if mobj.z < pmo.z + 90*FRACUNIT and mobj.z > pmo.z - 30*FRACUNIT and mobj ~= pmo and not mobj.player then
		if (mobj.flags == MT_METALSONIC_BATTLE) then
			if mobj.state == mobj.info.spawnstate then
				mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh), FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)))
				if P_RandomChance(FRACUNIT / 2) then movedir = InvAngle(mobj.movedir) end
				mobj.threshold = 6 + (FixedMul(24 << FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)) >> FRACBITS)
				S_StartSound(mobj, mobj.info.activesound)
				mobj.state = mobj.info.painchance
				mobj.flags2 = $ & ~MF2_INVERTAIMABLE
			end
		elseif (mobj.flags & MF_SHOOTABLE) then
			if (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS) then
				P_DamageMobj(mobj, pmo, pmo)
			else
				P_KillMobj(mobj, pmo, pmo)
			end
		end
	end
end

local function attractShield(pmo, mobj)
	local p = pmo.player
	if (mobj.z < pmo.z + 300*pmo.scale) and (mobj.z > pmo.z - 300*pmo.scale) and (mobj.flags & MF_ENEMY) then
		if not (leveltime%2) then
			local thok = P_SpawnMobjFromMobj(mobj, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, MT_DUMMYOBJ)
			thok.sprite = SPR_WZAP
			thok.frame = FF_FULLBRIGHT|A
			thok.color = SKINCOLOR_GOLD
			thok.colorized = true
			thok.tics = 10
			thok.fuse = 10
			thok.scale = 3*FRACUNIT
			thok.destscale = 1

			local dist = P_AproxDistance(P_AproxDistance(pmo.x - thok.x, pmo.y - thok.y), pmo.z - thok.z)
			thok.momx = FixedMul(FixedDiv(pmo.x - thok.x, dist), 30*FRACUNIT)
			thok.momy = FixedMul(FixedDiv(pmo.y - thok.y, dist), 30*FRACUNIT)
			thok.momz = FixedMul(FixedDiv(pmo.z - thok.z, dist), 30*FRACUNIT)

			if not S_SoundPlaying(mobj, sfx_s3k5c) then S_StartSound(mobj, sfx_s3k5c) end
		end

		mobj.momx = $ + (pmo.x - mobj.x)/60
		mobj.momy = $ + (pmo.y - mobj.y)/60
		mobj.momz = $ + (pmo.z - mobj.z)/60
	end
end

rawset(_G, "Flimp_MainThinker", function(p)
	if p.mo.skin ~= "flimp" then
		p.mo.flimp_headbutting = nil
		p.mo.flimp_diving = nil
		p.mo.flimp_flying = nil
		p.mo.flimp_flight = nil
		p.mo.flimp_didflying = nil
		p.mo.flimp_diddive = nil
		p.mo.flimp_nodive = nil
		p.mo.flimp_squish = nil

		if p.mo.flimp_duckdance then
			p.mo.state = S_PLAY_STND
			p.mo.flimp_duckdance = nil
			P_RestoreMusic(p)
		end

		return
	end

	if p.playerstate == PST_DEAD then return end

	-- Reset everything
	if P_PlayerInPain(p) or p.playerstate == PST_DEAD or (p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_ROPEHANG or p.powers[pw_carry] == CR_MINECART) then
		p.mo.flimp_headbutting = nil
		p.mo.flimp_diving = nil
		p.mo.flimp_flying = nil
		p.mo.flimp_flight = nil
		p.mo.flimp_didflying = nil
		p.mo.flimp_diddive = nil
		p.mo.flimp_nodive = nil
		p.mo.flimp_squish = nil
		p.mo.flimp_duckdance = nil
		p.mo.flimp_bubblewrap = nil
		p.mo.flimp_parry = nil
		p.mo.flimp_parry_invuln = nil
		p.mo.flameaura_dashes = nil
		p.mo.flameaura_timer = nil
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
		p.pflags = $ & ~PF_CANCARRY

		if (p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_ROPEHANG) and p.mo.buttons.jump == 1 then
			P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
			p.powers[pw_carry] = 0
		end

		return
	end

	-- Parry?
	if p.mo.flimp_parry_invuln then
		p.mo.flimp_parry_invuln = $-1
		if p.mo.flimp_parry_invuln <= 0 then p.mo.flimp_parry_invuln = nil end
	end

	if (p.powers[pw_shield] & SH_FORCE) then
		if p.mo.flimp_parry then
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = -p.mo.flimp_parry*P_MobjFlip(p.mo)*FRACUNIT/8

			p.mo.flimp_parry = $-1
			if p.mo.flimp_parry == 20 then p.pflags = $ & ~PF_SHIELDABILITY end

			if p.mo.flimp_parry <= 0 then
				p.mo.state = S_PLAY_FALL
				p.mo.flimp_parry = nil
			elseif p.mo.flimp_parry <= 18 then
				p.mo.sprite2 = SPR2_TRNS
				p.mo.frame = B
			end

			return
		end

		if (p.mo.buttons.jump > 0 and p.mo.buttons.spin > 0 and p.mo.buttons.jump <= 3 and p.mo.buttons.spin <= 3) then
			p.mo.state = S_PLAY_FALL
			p.mo.sprite2 = SPR2_MLEL
			p.mo.frame = A
			p.mo.flimp_parry = 25
			S_StartSound(p.mo, sfx_fparry)
			p.pflags = $|PF_SHIELDABILITY

			p.mo.flimp_headbutting = nil
			p.mo.flimp_diving = nil
			p.mo.flimp_flying = nil
			p.mo.flimp_flight = nil
			p.mo.flimp_didflying = nil
			p.mo.flimp_diddive = nil
			p.mo.flimp_nodive = nil
			p.mo.flimp_squish = nil
			p.mo.flimp_duckdance = nil
			p.mo.flimp_bubblewrap = nil
			p.mo.flameaura_dashes = nil
			p.mo.flameaura_timer = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			p.pflags = $ & ~PF_CANCARRY

			if (p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_ROPEHANG) and p.mo.buttons.jump == 1 then
				P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
				p.powers[pw_carry] = 0
			end

			return
		end
	end
	
	-- Flimp has less gravity. Also handle the squish sound, in both regular gameplay and nights.
	if p.powers[pw_carry] ~= CR_NIGHTSMODE then
		if not P_IsObjectOnGround(p.mo) then
			P_SetObjectMomZ(p.mo, (gravity/6), true)
			p.mo.flimp_didsquish = nil
			if hasShield(p, SH_BUBBLEWRAP) then p.mo.flimp_bubblereset = {p.mo.momx, p.mo.momy, -p.mo.momz, p.drawangle} end
		else
			p.mo.flimp_flight = nil
			p.mo.flimp_headbutting = nil
			p.mo.flimp_didflying = nil
			p.mo.flimp_nodive = nil
			p.mo.flameaura_dashes = nil

			if p.mo.flimp_diving then
				if hasShield(p, SH_BUBBLEWRAP) then
					p.mo.flimp_squish = 10
					p.mo.flimp_bubblewrap = 10
					p.mo.flimp_didsquish = true
					p.mo.flimp_diving = nil

					S_StartSound(p.mo, sfx_s3k44)
					S_StartSound(p.mo, sfx_dogt2)
				else
					p.mo.flimp_squish = 25
					p.mo.flimp_sliding = p.mo.flimp_diving
					p.mo.flimp_diving = nil
					p.mo.flimp_didsquish = true
					S_StartSound(p.mo, sfx_dogtoy)
				end
			elseif not p.mo.flimp_didsquish then
				p.mo.flimp_squish = 5
				p.mo.flimp_didsquish = true
				S_StartSound(p.mo, sfx_dogtoy)
			end
		end
	else
		if not p.mo.flimp_squish and (P_IsObjectOnGround(p.mo) or (p.mo.z + p.mo.height) >= p.mo.ceilingz) then
			p.mo.flimp_squish = 5
			S_StartSound(p.mo, sfx_dogtoy)
		end
	end

	-- Squish Animation
	if p.mo.flimp_squish then
		p.mo.spritexscale = FRACUNIT + (p.mo.flimp_squish*FRACUNIT/25)
		p.mo.spriteyscale = FRACUNIT - (p.mo.flimp_squish*FRACUNIT/25)

		p.mo.flimp_squish = $-1
		if p.mo.flimp_squish <= 0 or not P_IsObjectOnGround(p.mo) then
			p.mo.flimp_squish = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end
	end

	-- Spring Flag
	if p.mo.flimp_autospringremove then
		p.mo.flimp_autospringremove = $-1
		if p.mo.flimp_autospringremove <= 0 then
			p.powers[pw_strong] = $ & ~STR_SPRING
			p.mo.flimp_autospringremove = nil
		end
	end

	-- Super Animation
	if p.powers[pw_super] or p.powers[pw_carry] == CR_NIGHTSMODE then
		local spriteframe = max(0, min(2, (leveltime%6)/2))

		local spark
		if not p.mo.flimp_originalaura or not p.mo.flimp_originalaura.valid then
			spark = P_SpawnMobjFromMobj(p.mo, cos(R_PointToAngle(p.mo.x, p.mo.y)), sin(R_PointToAngle(p.mo.x, p.mo.y)), 0, MT_DUMMYOBJ)
			spark.momx = p.mo.momx
			spark.momy = p.mo.momy
			spark.momz = p.mo.momz
			spark.flags = $|MF_NOCLIPHEIGHT
			spark.sprite = SPR_SUPF
			spark.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
			spark.blendmode = AST_ADD
			spark.color = p.mo.color
			spark.colorized = true
			spark.fuse = 5

			p.mo.flimp_originalaura = spark
		else
			spark = p.mo.flimp_originalaura

			P_MoveOrigin(p.mo.flimp_originalaura, p.mo.x + cos(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.y + sin(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.z)
			spark.momx = p.mo.momx
			spark.momy = p.mo.momy
			spark.momz = p.mo.momz
			spark.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
			spark.scale = p.mo.scale
			spark.color = p.mo.color
			spark.fuse = 5
		end

		if not p.mo.flimp_superauras then p.mo.flimp_superauras = {} end

		for i = 11, 13 do
			if not p.mo.flimp_superauras[i] or not p.mo.flimp_superauras[i].valid then
				spark = P_SpawnMobjFromMobj(p.mo, cos(R_PointToAngle(p.mo.x, p.mo.y)), sin(R_PointToAngle(p.mo.x, p.mo.y)), 0, MT_DUMMYOBJ)
				spark.flags = $|MF_NOCLIPHEIGHT
				spark.momx = p.mo.momx
				spark.momy = p.mo.momy
				spark.momz = p.mo.momz
				spark.sprite = SPR_SUPF
				spark.frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
				spark.scale = (p.mo.scale/10)*i
				spark.blendmode = AST_ADD
				spark.color = p.mo.color
				spark.colorized = true
				spark.fuse = 5

				p.mo.flimp_superauras[i] = spark
			else
				spark = p.mo.flimp_superauras[i]

				P_MoveOrigin(spark, p.mo.x + cos(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.y + sin(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.z)
				spark.frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
				spark.scale = (p.mo.scale/10)*i
				spark.color = p.mo.color
				spark.fuse = 5
				spark.momx = p.mo.momx
				spark.momy = p.mo.momy
				spark.momz = p.mo.momz
			end
		end

		if not (leveltime%5) then
			spark = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, MT_BOXSPARKLE)
			spark.scale = 2*FRACUNIT
			spark.destscale = 1
			spark.color = p.mo.color
			spark.colorized = true
			spark.fuse = 20
		end
	end

	-- We probably won't need to run the rest of this code while in the hitstop...
	if p.mo.flimp_bubblewrap then
		local reset = p.mo.flimp_bubblereset or {0, 0, 0, 0}

		p.mo.flimp_bubblewrap = $-1
		p.drawangle = reset[4] or 0
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0

		if p.mo.flimp_bubblewrap <= 0 then
			p.mo.momx = reset[1] or 0
			p.mo.momy = reset[2] or 0
			p.mo.momz = (reset[3] or 0)/2
		else
			return
		end
	end

	if p.powers[pw_carry] == CR_NIGHTSMODE then return end

	-- Headbutt
	if p.mo.flimp_headbutt_anim then
		p.mo.flimp_headbutt_anim = $-1
		if p.mo.flimp_headbutt_anim <= 0 then p.mo.flimp_headbutt_anim = nil end

		if not (leveltime%9) then
			local j = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_DUMMYOBJ)
			j.sprite = SPR_BLBS
			j.frame = FF_FULLBRIGHT|FF_TRANS50|FF_PAPERSPRITE|A
			j.fuse = TICRATE
			j.scale = p.mo.scale
			j.destscale = 5*p.mo.scale
			j.angle = p.drawangle+ANGLE_90
		end
	end

	-- Flight
	if (p.cmd.buttons & BT_JUMP) and not p.nightstime and ((not p.mo.flimp_flight or p.mo.flimp_flight <= 40) or p.powers[pw_super]) and not p.mo.flimp_diving and not P_PlayerInPain(p) and not p.exiting then
		p.mo.flimp_flying = true
	end

	if p.mo.flimp_didflying and not hasShield(p, SH_THUNDERCOIN) then
		p.pflags = $|PF_CANCARRY
	end

	if p.mo.flimp_flying then
		if hasShield(p, SH_THUNDERCOIN) then
			local thok

			p.mo.flags2 = $|MF2_DONTDRAW
			p.mo.flimp_flight = $ and $+1 or 1

			p.shieldscale = 1
			P_SetObjectMomZ(p.mo, 50*FRACUNIT)

			thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
			thok.sprite = SPR_WZAP
			thok.frame = FF_FULLBRIGHT|A
			thok.color = SKINCOLOR_WHITE
			thok.colorized = true
			thok.momx = P_RandomRange(-5, 5)*FRACUNIT
			thok.momy = P_RandomRange(-5, 5)*FRACUNIT
			thok.momz = P_RandomRange(-5, 5)*FRACUNIT

			if p.mo.funnyThok and p.mo.funnyThok.valid then
				thok = p.mo.funnyThok
				P_MoveOrigin(thok, p.mo.x, p.mo.y, p.mo.z)
			else
				thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
				thok.scale = 7*p.mo.scale/8
				thok.color = SKINCOLOR_WHITE
				thok.colorized = true
				thok.frame = FF_FULLBRIGHT|A
				thok.spriteyscale = (p.mo.flimp_flight > 10) and 5*FRACUNIT/2 or FRACUNIT
				thok.tics = 30
				thok.fuse = 30

				p.mo.funnyThok = thok
			end

			thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
			thok.color = SKINCOLOR_ICY
			thok.colorized = true
			thok.frame = FF_FULLBRIGHT|FF_TRANS20|A
			thok.blendmode = AST_ADD
			thok.tics = 40
			thok.fuse = 40
			thok.destscale = 1
			thok.scalespeed = FRACUNIT/20
			thok.spriteyscale = (p.mo.flimp_flight > 10) and 5*FRACUNIT/2 or FRACUNIT
			if p.mo.momz <= -FRACUNIT then p.mo.momz = -FRACUNIT end

			local dist = 80*FRACUNIT
			searchBlockmap("objects", flightDamage, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist)

			if p.mo.flimp_flight == 1 then
				S_StartSound(p.mo, sfx_s3k45)

				local spark
				for i = 1, 16 do
					spark = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THUNDERCOIN_SPARK)
					spark.momx, spark.momy, spark.momz = 10*cos(((ANG10*36)/16)*i), 10*sin(((ANG10*36)/16)*i), -5*FRACUNIT
					spark.fuse = 31
				end
			end

			if p.mo.flimp_flight >= 10 then
				P_SetObjectMomZ(p.mo, 10*FRACUNIT)
				S_StartSound(p.mo, sfx_s3ka6)
				p.mo.flags2 = $ & ~MF2_DONTDRAW
				p.shieldscale = 7*FRACUNIT/10
				p.pflags = $ & ~PF_SPINNING
				p.mo.funnyThok = nil

				if p.mo.funnyThok and p.mo.funnyThok.valid then
					thok = p.mo.funnyThok
					thok.destscale = 3*FRACUNIT
					thok.tics = 10
					thok.fuse = 10
				end

				S_StartSound(p.mo, sfx_s3kbb)
				S_StartSound(p.mo, sfx_kc44)
				p.mo.state = S_PLAY_FALL
				p.mo.flimp_flight = 60
				p.mo.flimp_flying = nil
			end
		else
			p.shieldscale = 7*FRACUNIT/10

			local spd = 2*FRACUNIT
			if abs(p.mo.momz) <= 0 then spd = $*3 end

			if hasShield(p, SH_WHIRLWIND) then
				if not p.mo.flimp_whirlwind then p.mo.flimp_whirlwind = {} end

				local dust
				local dist = 25
				if not (leveltime%2) and #p.mo.flimp_whirlwind < 10 then
					local i = P_RandomRange(1, 5)
					dust = P_SpawnMobjFromMobj(p.mo, dist*FixedMul(p.mo.scale, cos(p.drawangle+(i*72*ANG1))), dist*FixedMul(p.mo.scale, sin(p.drawangle+(i*72*ANG1))), 0, MT_DUSTLAYER)
					dust.angle = (i*72*ANG1)-ANGLE_90
					dust.offset = i
					dust.upwardz = 3*FRACUNIT
					dust.tics = 10
					dust.fuse = 10
					dust.color = color or SKINCOLOR_GREY
					dust.colorized = colorize or false
					dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
					dust.height = FRACUNIT
					dust.scale = FRACUNIT/2
					p.mo.flimp_whirlwind[#p.mo.flimp_whirlwind+1] = dust
				end

				spd = $*3/2

				dist = 30*FRACUNIT
				searchBlockmap("objects", flightDamage, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist)
			-- attraction shield
			elseif hasShield(p, SH_ATTRACT) then
				local dist = 200*FRACUNIT
				searchBlockmap("objects", attractShield, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist)

				dist = 35*FRACUNIT
				searchBlockmap("objects", flightDamage, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist)
			end

			if ((p.mo.flags2 & MF2_OBJECTFLIP) and p.mo.momz >= -15*FRACUNIT) or ((not (p.mo.flags2 & MF2_OBJECTFLIP)) and p.mo.momz <= 15*FRACUNIT) then P_SetObjectMomZ(p.mo, (p.mo.eflags & MFE_UNDERWATER) and spd/3 or spd, true) end

			if not S_SoundPlaying(p.mo, sfx_s3ka6) then S_StartSound(p.mo, sfx_s3ka6) end
			p.mo.flimp_flight = $ and $+1 or 1
			p.mo.flimp_headbutting = nil
			p.mo.flimp_flying = true
			p.mo.flimp_didflying = true
			p.mo.state = S_PLAY_FLY

			-- whirlwind boosts speed and time
			if (p.mo.flimp_flight >= (hasShield(p, SH_WHIRLWIND) and 60 or 40)) and not p.powers[pw_super] then
				S_StartSound(p.mo, sfx_s3kbb)
				S_StartSound(p.mo, sfx_kc44)
				p.mo.state = S_PLAY_FALL
				p.mo.flimp_flying = nil
			elseif not (p.cmd.buttons & BT_JUMP) then
				S_StartSound(p.mo, sfx_s3kbb)
				p.mo.state = S_PLAY_FALL
				p.mo.flimp_flying = nil
			end
		end
	end

	if p.mo.flimp_whirlwind and #p.mo.flimp_whirlwind then
		local dust
		local dist = 25
		local newtbl = {}
		local rotoffset = 0
		local rotoffset2 = 0

		local i, no_inc = 1, false
		while p.mo.flimp_whirlwind[i] do
			no_inc = false
			dust = p.mo.flimp_whirlwind[i]

			if dust and dust.valid then
				if dust.upwardz < 60*FRACUNIT then
					rotoffset = dist+5
					rotoffset2 = 64
					P_MoveOrigin(dust, p.mo.x + rotoffset*cos((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.y + rotoffset*sin((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.z + dust.upwardz)
					dust.upwardz = $+FRACUNIT
					dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

					if dust.upwardz >= 15*FRACUNIT then
						dust.momx = p.mo.momx
						dust.momy = p.mo.momy
						dust.momz = p.mo.momz
						dust.tics = 5
						dust.fuse = 5
						table.remove(p.mo.flimp_whirlwind, i)
						no_inc = true
					end
				end

				if not no_inc then i = $+1 end
			else
				table.remove(p.mo.flimp_whirlwind, i)
			end
		end
	end

	-- Headbutt
	if p.mo.flimp_headbutting and not srb2p then
		p.drawangle = p.mo.flimp_headbutting
		p.powers[pw_strong] = $|STR_SPRING
		p.mo.flimp_autospringremove = 5
		tornadoBust(p)

		p.mo.flimp_headbutt_timer = $ and $+1 or 1

/*
		if p.mo.flimp_headbutt_timer <= 5 and p.mo.buttons.jump == 1 then
			P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 25*FRACUNIT or 10*FRACUNIT)
			P_SetObjectMomZ(p.mo, -10*FRACUNIT, true)
			S_StartSound(p.mo, sfx_s3ka0)
			p.mo.flimp_flying = nil
			p.mo.flimp_diving = p.mo.angle
			p.pflags = $|PF_SHIELDABILITY
			p.mo.flimp_headbutt_timer = nil
			p.mo.flimp_headbutting = nil
			p.mo.flimp_headbutt_anim = 1
		end
*/

		if p.powers[pw_pushing] then
			S_StartSound(p.mo, sfx_pstop)
			P_InstaThrust(p.mo, p.mo.flimp_headbutting, -10*FRACUNIT)
			P_SetObjectMomZ(p.mo, 7*FRACUNIT)

			p.mo.flimp_headbutting = nil
			p.mo.flimp_headbutt_anim = 1
		end
	end

	if P_IsObjectOnGround(p.mo) and not p.mo.flimp_headbutting and p.mo.buttons.spin == 1 and not P_PlayerInPain(p) and not p.exiting and not srb2p then
		S_StartSound(p.mo, sfx_s3ka2)
		P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 40*FRACUNIT or 20*FRACUNIT)
		P_SetObjectMomZ(p.mo, 8*FRACUNIT, true)
		p.mo.flimp_headbutting = p.drawangle
		p.mo.flimp_headbutt_anim = 35
		p.mo.flimp_headbutt_timer = 1
		p.mo.state = S_PLAY_FLY
	end

	-- Dive
	if not P_IsObjectOnGround(p.mo) and not p.mo.flimp_headbutting and not p.mo.flimp_diving and p.mo.buttons.spin == 1 and not P_PlayerInPain(p) and not p.exiting and not srb2p and not p.mo.flimp_nodive and not (p.mo.eflags & MFE_GOOWATER) then
		if All7Emeralds(emeralds) and (p.rings >= 50) and (p.powers[pw_shield] == SH_NONE) and not p.powers[pw_super] then
			P_DoSuperTransformation(p)
		else
			if hasShield(p, SH_ELEMENTAL) then p.pflags = $|PF_SHIELDABILITY end

			if p.powers[pw_super] or hasShield(p, SH_ARMAGEDDON) or (hasShield(p, SH_FLAMEAURA) and (not p.mo.flameaura_dashes or p.mo.flameaura_dashes < 3)) then
				p.mo.flameaura_timer = nil
				if hasShield(p, SH_FLAMEAURA) then
					S_StartSound(p.mo, sfx_s3k43)
					p.pflags = $|PF_SHIELDABILITY
					p.mo.flameaura_dashes = $ and $+1 or 1

					local fire
					for i = 1, 10 do
						fire = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)

						if fire and fire.valid then
							fire.sprite = SPR_SFBR
							fire.frame = FF_FULLBRIGHT|A
							fire.rollangle = P_RandomRange(0, 360)*ANG1
							fire.momx = P_RandomRange(-10, 10)*FRACUNIT
							fire.momy = P_RandomRange(-10, 10)*FRACUNIT
							fire.momz = P_RandomRange(-10, 10)*FRACUNIT
							fire.destscale = 1
							fire.fuse = 35
							fire.tics = 35
						end
					end
				end

				if not hasShield(p, SH_FLAMEAURA) then P_Thrust(p.mo, p.drawangle, 40*FRACUNIT) end
				S_StartSound(p.mo, sfx_s3ka0)
				p.mo.flimp_flying = nil
				p.mo.flimp_diving = p.mo.angle
			elseif not (hasShield(p, SH_FLAMEAURA) and p.mo.flameaura_dashes and p.mo.flameaura_dashes >= 3) then
				P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 25*FRACUNIT or 10*FRACUNIT)
				P_SetObjectMomZ(p.mo, -10*FRACUNIT, true)
				S_StartSound(p.mo, sfx_s3ka0)
				p.mo.flimp_flying = nil
				p.mo.flimp_diving = p.mo.angle
				p.pflags = $|PF_SHIELDABILITY
			end
		end
	end

	if p.mo.flimp_diving and not srb2p then
		if p.powers[pw_super] or hasShield(p, SH_ARMAGEDDON) or hasShield(p, SH_FLAMEAURA) then
			p.powers[pw_strong] = $|STR_SPRING
			p.mo.flimp_autospringremove = 5

			p.drawangle = p.mo.flimp_diving
			p.mo.flimp_headbutt_anim = 35
			P_Thrust(p.mo, p.mo.flimp_diving, 5*FRACUNIT)
			P_SetObjectMomZ(p.mo, 0)
			p.powers[pw_nocontrol] = 32773

			if (p.cmd.buttons & BT_JUMP) and not p.nightstime and ((not p.mo.flimp_flight or p.mo.flimp_flight <= 40) or p.powers[pw_super]) and not p.mo.flimp_diving and not P_PlayerInPain(p) and not p.exiting then
				p.mo.flimp_flying = true
				p.mo.flimp_headbutt_anim = 1
				p.mo.flimp_diving = nil
			end

			if hasShield(p, SH_FLAMEAURA) then
				p.mo.flameaura_timer = $ and $+1 or 1

				local fire = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)

				if fire and fire.valid then
					fire.sprite = SPR_SFBR
					fire.frame = FF_FULLBRIGHT|A
					fire.rollangle = P_RandomRange(0, 360)*ANG1
					fire.momx = P_RandomRange(0, 10)*cos(p.drawangle + P_RandomRange(-10, 10)*ANG1)
					fire.momy = P_RandomRange(0, 10)*cos(p.drawangle + P_RandomRange(-10, 10)*ANG1)
					fire.momz = P_RandomRange(-2, 2)*FRACUNIT
					fire.destscale = FRACUNIT/3
					fire.fuse = 18
					fire.tics = 18
				end

				if p.mo.flameaura_timer >= 10 then
					p.pflags = $ & ~PF_SHIELDABILITY

					p.powers[pw_nocontrol] = 0
					p.mo.flimp_headbutt_anim = 1
					p.mo.flimp_diving = nil
					p.mo.flameaura_timer = nil
					p.mo.buttons.spin = 0

					for i = 1, 10 do
						fire = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)

						if fire and fire.valid then
							fire.sprite = SPR_SFBR
							fire.frame = FF_FULLBRIGHT|A
							fire.rollangle = P_RandomRange(0, 360)*ANG1
							fire.momx = P_RandomRange(-10, 10)*FRACUNIT
							fire.momy = P_RandomRange(-10, 10)*FRACUNIT
							fire.momz = P_RandomRange(-10, 10)*FRACUNIT
							fire.destscale = 1
							fire.fuse = 35
							fire.tics = 35
						end
					end
				end
			elseif p.powers[pw_pushing] then
				if hasShield(p, SH_ARMAGEDDON) then P_BlackOw(p) end
				S_StartSound(p.mo, sfx_pstop)
				P_InstaThrust(p.mo, p.mo.flimp_diving, -10*FRACUNIT)
				P_SetObjectMomZ(p.mo, 7*FRACUNIT)
				p.powers[pw_nocontrol] = 0
				p.mo.flimp_headbutt_anim = 1
				p.mo.flimp_diving = nil
				p.mo.flameaura_timer = nil
				p.mo.buttons.spin = 0
			end
		else
			p.powers[pw_strong] = $|STR_SPRING
			p.mo.flimp_autospringremove = 5
			tornadoBust(p)

			p.drawangle = p.mo.flimp_diving
			P_Thrust(p.mo, p.mo.flimp_diving, FRACUNIT/2)
			P_SetObjectMomZ(p.mo, -2*FRACUNIT, true)

			if (p.cmd.buttons & BT_JUMP) and not p.nightstime and not P_PlayerInPain(p) and not p.exiting then
				S_StartSound(p.mo, sfx_s3ka2)
				P_Thrust(p.mo, p.mo.angle, p.speed <= 5*FRACUNIT and 40*FRACUNIT or 20*FRACUNIT)
				P_SetObjectMomZ(p.mo, 4*FRACUNIT)
				p.mo.flimp_headbutting = p.mo.angle
				p.mo.flimp_headbutt_anim = 35
				p.mo.flimp_headbutt_timer = 1
				p.mo.flimp_diving = nil
				p.mo.flimp_nodive = true
				p.mo.state = S_PLAY_FLY
			end

			if (p.mo.eflags & MFE_GOOWATER) then
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				S_StartSound(p.mo, sfx_s3k49)
				P_SetObjectMomZ(p.mo, -20*FRACUNIT, true)

				local goop
				for i = 1, 16 do
					goop = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
					P_InstaThrust(goop, i*ANGLE_22h, 18*FRACUNIT)
	--				P_SetObjectMomZ(goop, 10*FRACUNIT)

					goop.color = SKINCOLOR_LAVENDER
					goop.colorized = true
				end

				p.mo.flimp_diving = nil
				p.pflags = $ & ~PF_SHIELDABILITY
			end
		end
	end

	-- Sliding 
	if p.mo.flimp_sliding and not srb2p then
		p.drawangle = p.mo.flimp_sliding
		p.pflags = $|PF_SPINNING
		if not S_SoundPlaying(p.mo, sfx_s3k7e) then S_StartSound(p.mo, sfx_s3k7e) end
		p.mo.state = S_PLAY_FALL

		if (not P_IsObjectOnGround(p.mo)) or P_PlayerInPain(p) or p.playerstate == PST_DEAD or p.speed <= 5*FRACUNIT or p.mo.flimp_headbutting then
			p.mo.flimp_sliding = nil
			p.mo.state = P_IsObjectOnGround(p.mo) and S_PLAY_STND or S_PLAY_FALL
			p.pflags = $ & ~PF_SPINNING
		end

		if not p.mo.flimp_squish then p.mo.flimp_squish = 4 end
	end

	-- Duck Dance
	if (p.cmd.buttons & BT_CUSTOM3) and p.speed <= 0 and P_IsObjectOnGround(p.mo) and not p.mo.flimp_duckdance and not p.tanukisuit and not p.mo.blossom_tanukianim then
		p.mo.flimp_duckdance = 1
		P_PlayJingleMusic(p, "HEYYA", nil, true, JT_OTHER)
	end

	if p.mo.flimp_duckdance then
		if p.speed > 0 or not P_IsObjectOnGround(p.mo) then
			p.mo.state = S_PLAY_STND
			p.mo.flimp_duckdance = nil
			P_RestoreMusic(p)
		else
			if p.mo.state ~= S_PLAY_BLOSSOM_DUCKDANCE then p.mo.state = S_PLAY_BLOSSOM_DUCKDANCE end
			if p.mo.blossom_flimp and p.mo.blossom_flimp.valid then p.mo.blossom_flimp.frame = p.mo.frame+1 end
		end
	end
end)