if not srb2p then return end

-- Blossom's base stats.
charStats["flimp"] = {
	name = "Flimp",
	basehp = 42,
	basesp = 55,
	persona = "none_flimp",
	melee_natk = "flimp_atk1",

	supercolor_start = SKINCOLOR_SUPERGOLD1,
	supername = "Super Flimp",

	atk = 40,
	acc = 999,
	crit = 7,

	wep = "flimp_01",
	weptype = WPT_HAMMER,

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},
	anim_stand_bored =	{SPR_PLAY, A, B, 17, "SPR2_WAIT"},
	anim_guard = 		{SPR_PLAY, A, 8, "SPR2_PAIN"},
	anim_move =			{SPR_PLAY, A, B, 6, "SPR2_WALK"},
	anim_run =			{SPR_PLAY, A, B, 2, "SPR2_RUN_"},
	anim_atk =			{SPR_PLAY, A, B, 3, "SPR2_RUN_"},
	anim_aoa_end =		{SPR_PLAY, A, 10, "SPR2_FALL"},
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_CNT1"},
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_CNT1"},
	anim_getup =		{SPR_PLAY, A, B, C, G, 3, "SPR2_TRNS"},
	anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},
	anim_revive =		{SPR_PLAY, A, 10, "SPR2_FALL"},
	anim_evoker =		{SPR_PLAY, A, 8, "SPR2_SPNG"},

	icon = "ICO_FMP",
	hudbust = "FMP_H",
	hudaoa = "H_FMPAOA",
	hudcutin = "FLIM_A",
	aoa_quote = "Mrrr...!",

	tip = "Learns powerful Wind magic, with strike as a backup. A glass cannon that can also help their allies deal immense damage, but is completely frail.",
}

-- The Persona(tm)
personaList["none_flimp"] = {
	name = "None",
	arcana = nil,

	sprite = SPR_PSN0,
	startframe = 0,

	anim_idle = 	{SPR_NULL, A},
	anim_atk = 		{SPR_NULL, A},

	-- Stats (at level 10)
	strength = 7,
	magic = 12,
	endurance = 5,
	luck = 7,
	agility = 9,

	weak = ATK_FIRE,
	resist = ATK_WIND|ATK_BLESS,

	skills = {
		{bionis and "hana" or "garu", 1},
		{"lunge", 4},
		{"makakaja", 7},
		{bionis and "mahana" or "magaru", 12},
		{"gale link", 16},

		{"sonic punch", 18, "lunge"},
		{bionis and "hanama" or "garula", 24, bionis and "hana" or "garu"},
		{"double link", 26},
		{"mamakakaja", 29, "makakaja"},
		{bionis and "forest boost" or "wind boost", 33},

		{"assault dive", 37, "sonic punch"},
		{bionis and "mahanama" or "magarula", 44, bionis and "mahana" or "magaru"},
		{"triple link", 47, "double link"},

		{"mind charge", 50},
		{"quadruple link", 54, "triple link"},
		{"gigantic fist", 57, "assault dive"},

		{bionis and "hanamadyne" or "garudyne", 61, bionis and "hanama" or "garula"},
		{bionis and "forest amp" or "wind amp", 66, bionis and "forest boost" or "wind boost"},

		{"infinite link", 72, "quadruple link"},
		{bionis and "mahanamadyne" or "magarudyne", 76, bionis and "mahanama" or "magarudyne"},
		{bionis and "yggdrasil" or "panta rhei", 81, bionis and "hanamadyne" or "garudyne"}
	},
}

-- Bionis stuff.
local didbionis = false
addHook("ThinkFrame", function()
	if didbionis then return end

	if bionis then
		personaList["skadi_blossom"].weak = $|ATK_POISON
		personaList["skadi_blossom"].resist = $|ATK_METAL
		didbionis = true
	end
end)