if not srb2p then return end

attackDefs["flimp_atk1"] = {
	name = "Headbutt",
	type = ATK_STRIKE,
	power = 40,
	accuracy = 95,
	critical = 7,
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	desc = "Bash your head against\nyour foes.",
	anim_norepel = true,
	physical = true,
	norandom = true,
	norogue = true,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]

		if timer <= TICRATE and not (leveltime%9) then
			local j = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUMMYOBJ)
			j.sprite = SPR_BLBS
			j.frame = FF_FULLBRIGHT|FF_TRANS50|FF_PAPERSPRITE|A
			j.fuse = TICRATE
			j.scale = mo.scale
			j.destscale = 5*mo.scale
			j.angle = mo.angle+ANGLE_90
		end
		
		if timer == 1 then
			ANIM_set(mo, mo.anim_atk, true)
			playSound(mo.battlen, sfx_s220)

			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

			local z = mo.z
			local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
			hit.tics = TICRATE

			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / TICRATE
			local vertical = FixedMul((gravity*TICRATE)/2, mo.scale)

			mo.momx = FixedMul(horizontal, cos(mo.angle))
			mo.momy = FixedMul(horizontal, sin(mo.angle))
			mo.momz = vertical

			local an = target.angle + 45*ANG1
			local cx = target.x + 384*cos(an)
			local cy = target.y + 384*sin(an)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
		elseif timer == TICRATE then
			ANIM_set(mo, mo.anim_aoa_end, true)
			damageObject(hittargets[1])
			P_InstaThrust(mo, 0, 0)

			localquake(mo.battlen, FRACUNIT*30, 8)
			playSound(mo.battlen, sfx_pstop)
		elseif timer == TICRATE*2
			return true
		end
	end,
}