if Spec_InputSys then return end -- We can just leech from any of my other mods.
rawset(_G, "Spec_InputSys", true)

local function doTap(p, input)
	if not _G["BT_"..input:upper()] then return end

	if p.mo.tap[input] == true then p.mo.tap[input] = false end

	if not (p.cmd.buttons & _G["BT_"..input:upper()]) and (p.mo.buttons[input] > 0 and p.mo.buttons[input] <= 5) then
		p.mo.tap[input] = true
	end
end

local function doHold(p, input)
	if not _G["BT_"..input:upper()] then return end

	if (p.cmd.buttons & _G["BT_"..input:upper()])
		p.mo.buttons[input] = $+1
	else
		p.mo.buttons[input] = 0
	end
end

local function inputReg(p, input)
	if not p.mo.buttons then p.mo.buttons = {} end
	if not p.mo.tap then p.mo.tap = {} end
	if not p.mo.buttons[input] then p.mo.buttons[input] = 0 end
	if not p.mo.tap[input] then p.mo.tap[input] = false end
	
	doTap(p, input)
	doHold(p, input)
end

local function CalcMovement(p, direction, check1, check2)
	if not p.mo.buttons then return end
	if not p.mo.buttons[direction] then p.mo.buttons[direction] = 0 end

	if p.mo.tap[direction] == true then p.mo.tap[direction] = false end
	if check1 and (p.mo.buttons[direction] > 0 and p.mo.buttons[direction] <= 5) then p.mo.tap[direction] = true end

	p.mo.buttons[direction] = (check2 and $ + 1) or 0
end

addHook("PlayerThink", function(p)
	if not p.mo or not p.mo.valid then return end

	p.mo.buttons = $ or {
		jump = 0,
		spin = 0,
		down = 0,
		up = 0,
		left = 0,
		right = 0,
		attack = 0,
		firenormal = 0,
		weaponnext = 0,
		weaponprev = 0,
		custom1 = 0,
		custom2 = 0,
		custom3 = 0,
		tossflag = 0,
	}

	p.mo.tap = $ or {
		jump = false,
		spin = false,
		down = false,
		up = false,
		left = false,
		right = false,
		attack = false,
		firenormal = false,
		weaponnext = false,
		weaponprev = false,
		custom1 = false,
		custom2 = false,
		custom3 = false,
		tossflag = false,
	}

	if p.powers[pw_nocontrol] <= 0 or p.powers[pw_nocontrol] >= 32768 then
		local inputs = {"jump", "spin", "tossflag", "attack", "firenormal", "weaponnext", "weaponprev"}
		for i = 1, 3 do inputs[#inputs+1] = "custom"..i end
		for i = 1, #inputs do inputReg(p, inputs[i]) end

		CalcMovement(p, "down", p.cmd.forwardmove >= 0, p.cmd.forwardmove < 0)
		CalcMovement(p, "up", p.cmd.forwardmove <= 0, p.cmd.forwardmove > 0)
		CalcMovement(p, "left", (p.cmd.buttons & BT_CAMLEFT) or (p.cmd.sidemove < 0), (p.cmd.buttons & BT_CAMLEFT) or (p.cmd.sidemove < 0))
		CalcMovement(p, "right", (p.cmd.buttons & BT_CAMRIGHT) or (p.cmd.sidemove > 0), (p.cmd.buttons & BT_CAMRIGHT) or (p.cmd.sidemove > 0))
	end
end)